#include "StdAfx.h"
#include "ItemPanel.h"
#include "Binding.h"
#include "ListBox.h"

//////////////////////////////////////////////////////////////////////////
//Item
//////////////////////////////////////////////////////////////////////////
CString Item::ToString()
{
	CString szItem;
	szItem.Format(_T("%x"), DWORD(this));
	return szItem;
}
BOOL Item::Select(BOOL bSelect)
{
	if (m_bSelected == bSelect) return FALSE;

	m_bSelected = bSelect;
	if (m_ItemPanel)
	{
		if (m_bSelected)
		{
			m_ItemPanel->Select();
		}
		else
		{
			m_ItemPanel->Unselect();
		}
	}
	return TRUE;
}
BOOL Item::IsSelected() 
{ 
	return m_bSelected; 
}
//////////////////////////////////////////////////////////////////////////
//ItemPanel
//////////////////////////////////////////////////////////////////////////
REGISTER_COMPONENT_CREATOR(_T("DefaultItemPanel"), ItemPanel);
ItemPanel::ItemPanel(void)
{
	m_Item = NULL;
}

ItemPanel::~ItemPanel(void)
{
}
void ItemPanel::OnHideNotify()
{
	__super::OnHideNotify();

	if (m_Item != NULL)
	{
		m_Item->Select(FALSE);
	}
}
void ItemPanel::SetItem(Item* pItem)
{
	if (m_Item != NULL)
	{
		m_Item->SetItemPanel(NULL);
	}
	m_Item = pItem;
	if (m_Item != NULL)
	{
		m_Item->SetItemPanel(this);
	}	
}
void ItemPanel::Select()
{
	this->OnSelected();
	this->Invalidate();
}
void ItemPanel::Unselect()
{
	this->OnUnselected();
	this->Invalidate();
}